"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.throttle = void 0;
const wait = (delay) => new Promise((res) => {
    setTimeout(() => {
        res();
    }, delay);
});
const throttle = (delay = 500) => {
    let last = 0;
    return function (target, propertyKey, descriptor) {
        const origin = descriptor === null || descriptor === void 0 ? void 0 : descriptor.value;
        descriptor.value = function (...args) {
            return __awaiter(this, void 0, void 0, function* () {
                const now = Date.now();
                let rest = Math.max(0, delay - (now - last));
                yield wait(rest);
                last = Date.now();
                return origin.apply(this, args);
            });
        };
    };
};
exports.throttle = throttle;
//# sourceMappingURL=throttle.js.map